# donkiweb_lib.js API
<table><tr>
<td><img src="etc/html/images/DonkiWeb.png" title="donkiWeb" width=100></td>
<td><b>donkiweb_lib.js</b> is a Javascript SCADA library that allows to create Tango Web GUIs.</td>
</tr></table>
 Web interfaces could be created with few lines of code, little Javascript knowledge required.

# donkiAddInspector( parent, options)
Adds an **Inspector** container to a panel. Inspector allows to create a list of widgets easily.
Every widget is created calling the API function donkiAdd followed by the widget name, i.e. donkiAddImage or donkiAddReadLabel.
Input arguments:
- parent: parent Inspector object
- options:
  - width: total width
  - height: total height
  - widgets_width: width of every widget (used mostly in horizontal inspectors)
  - name_width: width of the name part of widgets
  - full: set to true if you want the inspector to use all the parent width and height
  - widgets_per_row: number of widgets per row, default is 1 but you can change it if you want to pack several widgets in a row (useful for small widgets like checkboxes)
  - one_line: widgets are place one next to the other horizontaly

# donkiAddGridInspector( parent, options)
Adds a **GridInspector** container to a panel. GridInspector allows to arrange a set of widgets in a grid.
Every widget is created calling the API function donkiAdd followed by the widget name, i.e. donkiAddImage or donkiAddReadLabel.
Input arguments:
- parent: parent Inspector container
- options:
  - width: total width
  - height: total height
  - widgets_width: width of every widget (used mostly in horizontal inspectors)
  - name_width: width of the name part of widgets
  - full: set to true if you want the inspector to use all the parent width and height

# donkiAddLineBreak( parent ) 
Adds a **LineBreak** to an Inspector container
Input arguments:
- parent: parent Inspector container

# donkiAddSeparator( parent ) 
Adds a **Separator** line to an Inspector container
Input arguments:
- parent: parent Inspector container

# donkiAddSection( parent , name, options) 
Adds a **Section** to an Inspector container. A Section is like a group box that could be collapsed.
Input arguments:
- parent: parent Inspector container
- name: caption that will be shown on the section banner
- options:
  - collapsed: boolean option for selecting the default behavior of the section
  - widgets_per_row: number of widgets per row

# donkiAddTabsContainer( parent , options) 
Adds a **Tabs container** to an Inspector.
Input arguments:
- options:
  - mode: "vertical","horizontal"
  - size
  - width
  - height
  - autoswitch: allow autoswitch (switch when mouse over)

# donkiAddImage( parent, image_url, options)
Adds an **Image** to an Inspector.
Input arguments:
- image_url: path of the image file
- options:
  - width
  - height
  - row
  - row_span
  - col
  - col_span


# donkiAddLabel( parent, caption, options)
Adds a **Label** text to an Inspector.
Input arguments:
- caption: text string to be shown
- options:
  - align
  - color
  - width
  - height
  - row
  - row_span
  - col
  - col_span

# donkiAddReadLabel( parent, attrname, options)
Adds a **ReadLabel** to an Inspector, the widget shows the actual value of a Tango Attribute
Input arguments:
- attrname: Tango Attribute name
- options:
  - align
  - caption
  - width
  - height
  - row
  - row_span
  - col
  - col_span

# donkiAddReadColorLabel( parent, attrname, caption, options)
Adds a **ReadColorLabel** to an Inspector, the widget shows a text that changes the color on the base of the actual value of a Tango Attribute
Input arguments:
- attrname: Tango Attribute name
- options:
  - align
  - caption
  - lut
  - width
  - height
  - row
  - row_span
  - col
  - col_span

# donkiAddReadWriteLabel( parent, caption, attrname, options) 

# donkiAddReadTextArea( parent , attrname, options) 

# donkiAddCheckBox( parent , caption, attrname, options) 

# donkiAddBoolControl( parent , caption, attrname, labels, options) 
    /**
    * Widget that create a Button for sending a Tango Command
    * Options:
    * - width,height
    * - confirm: enable confirmation popup (boolean)
    */

# donkiAddCommandButton( parent, caption, cmdname, options) 
{
    /**
    * Widget that create a Button for sending a Tango Command
    * Options:
    * - width,height
    * - confirm: enable confirmation popup (boolean)
    */

# donkiAddReadSVG( parent , attrname, options) 

# donkiAddSynopticContainer( parent, bgnd_image = "/html/synoptic_images/bgnd_pipe_img.svg" ) 
{
    aSYN = new SynopticContainer(parent, bgnd_image);
    return aSYN
}

# donkiAddSynopticElement( parent , image = "", title = "", imgattr = "" , alarmattr = "", labelattrs = [], options) 
{
# donkiAddPositionManager( parent, caption, attrname, options) 
{
    /**
    * Widget used for read/write Tango attributes, composed by an editable
    * label (absolute writing) and two buttons (+ and -) for relative
    * writng
    * Input arguments:
    * - parent
    * - caption
    * - attrname
    * - options:
    *    - step: used for relative writing
    */
# donkiAddDisableManager( target_widget, attrname, disable_list = []) 
{
    /**
    * Widget used for enable/disable other widgets
    * Input arguments:
    * - target_widget
    * - attrname
    * - conditions:
    */
