let starter_info = null;
const devstates = [
    "ON",
    "OFF",
    "CLOSE",
    "OPEN",
    "INSERT",
    "EXTRACT",
    "MOVING",
    "STANDBY",
    "FAULT",
    "INIT",
    "RUNNING",
    "ALARM",
    "DISABLE",
    "UNKNOWN"
];

function periodicCallback() {
    if (starter_info == null) return;
    //
    let web_url = "/tango-cs/GETATTR?force=true&td=" + starter_info["tangodev"];
    let req = new XMLHttpRequest();
    req.open('GET', web_url, false);
    req.send(null);
    if(req.status != 200) {
        console.log(req.status +" "+req.statusText);
        return;
    };
    let dReply = JSON.parse(req.responseText);
    servers_result = dReply[0];
    for (const key in servers_result.value) {
        let srvinfo = servers_result.value[key].split("\t");
        let srvelem = starter_info["js_elements"][srvinfo[0]];
        srvelem.setValue(srvinfo[1]);
    };
}


function donkiCreateTangoTree( tango_host, showpanel)
{
    //tree
    var mytree = { id: tango_host,    children: []};
    var litetree = new LiteGUI.Tree( mytree, { allow_rename: false, collapsed_depth: 1 });
    var guiPanel = showpanel;
    //
    LiteGUI.bind( litetree.root, "item_selected", function(e) {
        if ((typeof e.detail.data.children) !== 'boolean') return;
        guiPanel.clear()
        // reset global vars
        starter_info = null;
        let tdev = e.detail.data.content;
        populateWithJive(guiPanel, tdev);
    });
    litetree.clear(true);
    return litetree
};

function donkiFillTangoTree( tango_host, showpanel, litetree, view="Devices")
{
    //tree
    var mytree = { id: tango_host,    children: []};
    var guiPanel = showpanel;
    litetree.clear(true);
    //
    let req = new XMLHttpRequest();
    let web_url = "/tango-cs/BROWSE?th=" + tango_host + "&fullinfo=1";
    req.open('GET', web_url, false);
    req.send(null);
    if(req.status != 200) {
        onWriteError(req.status +" "+req.statusText);
        return;
    };
    let browse_result = JSON.parse(req.responseText);
    if (browse_result.reply !== "***OK") return litetree;
    //
    let tgdv_lst = eval(browse_result.value);
    for (let idx = 0; idx < tgdv_lst.length; idx += 1) {
        let tgdv = null;
        let tgds = null;
        let tgdc = null;
        let tgtokens = null;
        if (tgdv_lst[idx].constructor === Array) {
            tgdv = tgdv_lst[idx][0];
            tgdc = tgdv_lst[idx][1];
            tgds = tgdv_lst[idx][2];
        } else {
            tgdv = tgdv_lst[idx];
        }
        if (tgdv.split("/")[0] == "dserver") continue;
        if (view == "Devices") {
            tgtokens = tgdv.split("/");
        } else if (view == "Servers") {
            if (tgds == null) continue;
            tgtokens = tgds.split("/");
        }
		//
		let lev1 = null;
		for (let ii1 = 0; ii1 < mytree.children.length; ii1 += 1) {
			if (mytree.children[ii1].content.trim() === tgtokens[0]) {
				lev1 = ii1;
				break;
			}
		};
		if (lev1 === null) {
			lev1 = mytree.children.length;
			mytree.children.push({id:tgtokens[0], content: tgtokens[0], children: []});
		};
		//
		let lev2 = null;
		for (let ii2 = 0; ii2 < mytree.children[lev1].children.length; ii2 += 1) {
			if (mytree.children[lev1].children[ii2].content.trim() === tgtokens[1]) {
				lev2 = ii2;
				break;
			}
		};
		if (lev2 === null) {
			lev2 = mytree.children[lev1].children.length;
			mytree.children[lev1].children.push({id: tgtokens[0]+"/"+tgtokens[1], content: tgtokens[1], children: []});
		};
		//
		mytree.children[lev1].children[lev2].children.push({id: tgdv, content: tgdv, children: false});
    };
    mytree.children.sort((a, b) => a.id.toLowerCase() > b.id.toLowerCase() ? 1 : -1);
    litetree.updateTree(mytree);
    return litetree
};


function populateWithJive( parent , tdev)
{
    //
    function readButtonClicked(){
        //
        var req = new XMLHttpRequest();
        let web_url = "/tango-cs/GETATTR?force=true&td=" + selected_attr;
        req.open('GET', web_url, false);
        req.send(null);
        if(req.status != 200) {
            onWriteError(req.status +" "+req.statusText);
            return;
        };
        let dReply = JSON.parse(req.responseText)
        let out_str = "";
        if (Array.isArray(dReply)) {
            let date = new Date(0);
            if ('name' in dReply[0])
                out_str += "Attribute: " + dReply[0].name;
            if ('time' in dReply[0]) {
                date.setSeconds(Math.floor(dReply[0].time));
                out_str += "\nMeasure Time: " + date.toISOString().substr(0, 19);
                };
            if ('quality' in dReply[0])
                out_str += "\nQuality: " + dReply[0].quality;
            if ('value' in dReply[0]) {
                if (('type_name' in dReply[0]) && (dReply[0].type_name == "DevState"))
                    out_str += "\n\nRead: " + devstates[dReply[0].value] + " ("+dReply[0].value+")";
                else
                    out_str += "\n\nRead: " + dReply[0].value;
            }
        } else  {
            out_str = dReply.reply;
        };
        aReply.setValue(out_str);
    };
    //
    function writeButtonClicked(){
        var req = new XMLHttpRequest();
        var web_url = "/tango-cs/ATTRINFO?td=" + selected_attr;
        req.open('GET', web_url, false);
        req.send(null);
        if(req.status != 200) {
            onWriteError(req.status +" "+req.statusText);
            return;
        };
        let dInfo = JSON.parse(req.responseText);
        // Manage attributes
        if (SUPPORTED_TYPES.includes(dInfo.data_type)) {
            const web_url = "/tango-cs/SETATTR?td=" + selected_attr +"," + aArgin.getValue();
            //LiteGUI.requestText(web_url, aReply.setValue, aReply.setValue);
            req.open('GET', web_url, false);
            req.send(null);
            if(req.status != 200) {
                aReply.setValue(req.status +" "+req.statusText);
                return;
            };
            let dReply = JSON.parse(req.responseText)
            let out_str = "";
            let date = new Date(0);
            out_str += "Attribute: " + dReply.name;
            date.setSeconds(Math.floor(dReply.time));
            out_str += "\nWrite Time: " + date.toISOString().substr(0, 19);
            out_str += "\n\nReply: " + dReply.reply;
            aReply.setValue(out_str);
        } else  {
            aReply.setValue("Data type not supported");
        };
    };
    //
    function execButtonClicked() {
        function showReply(reply) {
            if (typeof reply === 'string') {
                cReply.setValue(reply);
            } else {
                let out_str = reply.reply;
                if(reply.retval !== null)
                    out_str += "\nArgout: "+reply.retval;
                cReply.setValue(out_str);
            };
        };
        var req = new XMLHttpRequest();
        var web_url = "/tango-cs/CMDINFO?td=" + selected_cmd;
        req.open('GET', web_url, false);
        req.send(null);
        if(req.status != 200) {
            onWriteError(req.status +" "+req.statusText);
            return;
        };
        let dInfo = JSON.parse(req.responseText);
        web_url = "/tango-cs/CMD?td=" + selected_cmd;
        // Manage commands
        if (SUPPORTED_TYPES.includes(dInfo.in_type)) {
            web_url = web_url +"," + cArgin.getValue();
        } else if (dInfo.in_type != 0) {
            cReply.setValue("Data type not supported");
            return;
        };
        //
        req.open('GET', web_url, false);
        req.send(null);
        if(req.status != 200) {
            cReply.setValue(req.status +" "+req.statusText);
            return;
        };
        let dReply = JSON.parse(req.responseText);
        let out_str = "";
        let date = new Date(0);
        out_str += "Command: " + dReply.name;
        date.setSeconds(Math.floor(dReply.time));
        out_str += "\nExec Time: " + date.toISOString().substr(0, 19);
        if ('value' in dReply) 
            out_str += "\n\nArgout: " + dReply.value;
        if ('reply' in dReply) 
            out_str += "\nReply: " + dReply.reply;
        cReply.setValue(out_str);
        //LiteGUI.requestJSON(web_url, showReply, showReply);
    };
    //
    function attrClicked() {
        var attrname = this.querySelector("li.selected").innerText;
        let infoText = "Name:\t\t"+attrname+"\n";
        infoText += "Writable:\t"+dInfo.Attributes[attrname].writable+"\n";
        infoText += "Data format:\t"+dInfo.Attributes[attrname].data_format+"\n";
        let type_msg = dInfo.Attributes[attrname].data_type_name;
        type_msg += " ["+dInfo.Attributes[attrname].data_type+"]";
        infoText += "Data type:\t"+type_msg+"\n";
        infoText += "Max dim x:\t"+dInfo.Attributes[attrname].max_dim_x+"\n";
        infoText += "Max dim y:\t"+dInfo.Attributes[attrname].max_dim_y+"\n";
        infoText += "Description:\t"+dInfo.Attributes[attrname].description+"\n";
        infoText += "Format:\t\t"+dInfo.Attributes[attrname].format+"\n";
        infoText += "Unit:\t\t"+dInfo.Attributes[attrname].unit+"\n";
        infoText += "Display unit:\t"+dInfo.Attributes[attrname].display_unit+"\n";
        infoText += "Standard unit:\t"+dInfo.Attributes[attrname].standard_unit+"\n";
        aInfo.setValue(infoText);
        if ([0,1].includes(dInfo.Attributes[attrname].writable)) waButton.disable();
        else waButton.enable();
        selected_attr = tdev + "/" + attrname;
    };
    //
    function cmdClicked() {
        var cmdname = this.querySelector("li.selected").innerText;
        let infoText = "Name:\t\t"+cmdname+"\n";
        let type_msg = dInfo.Commands[cmdname].in_type_name;
        type_msg += " ["+dInfo.Commands[cmdname].in_type+"]";
        infoText += "in_type:\t\t"+type_msg+"\n";
        infoText += "in_type_desc:\t"+dInfo.Commands[cmdname].in_type_desc+"\n";
        type_msg = dInfo.Commands[cmdname].out_type_name;
        type_msg += " ["+dInfo.Commands[cmdname].out_type+"]";
        infoText += "out_type:\t\t"+type_msg+"\n";
        infoText += "out_type_desc:\t"+dInfo.Commands[cmdname].out_type_desc+"\n";
        cInfo.setValue(infoText);
        if (dInfo.Commands[cmdname].in_type == 0) cArgin.disable();
        else cArgin.enable();
        selected_cmd = tdev + "/" + cmdname;
    };

    parent.root.querySelector(".panel-header").innerHTML = "Tango Device Control";
    var aInsp = donkiAddInspector(parent,{widgets_per_row: 3});
    //
    // Title
    var aL = donkiAddLabel(aInsp,tdev,{style:"font-weight: bold;"});
    aL.style.fontWeight = "bold";
    aL.style.fontSize = "large";
    aL.style.color = "lime";
    // Info
    //
    let req = new XMLHttpRequest();
    let web_url = "/tango-cs/GETFULLINFO?td=" + tdev;
    req.open('GET', web_url, false);
    req.send(null);
    if(req.status != 200) {
        onWriteError(req.status +" "+req.statusText);
        return;
    };
    let dInfo = JSON.parse(req.responseText);
    donkiAddSection(aInsp,"Info", {collapsed:(dInfo.reply == "***OK")});
    for (let prop in dInfo.info) {
        donkiAddLabel(aInsp,prop + ': ' + dInfo.info[prop],{style:"font-weight: bold;"});
    }
    if (dInfo.reply !== "***OK") {
        aL.style.color = "lightgray";
        aL.setValue(tdev + "<br><small><i><font color='orange'> [connection error]</font></i></small>");
        return;
    }
    //tabs 
    var tabs_widget = new LiteGUI.Tabs();
    tabs_widget.addTab("Commands");
    tabs_widget.addTab("Attributes",{selected:true, width: "100%", height: 400});
    //
    var attrInsp = new LiteGUI.Inspector({widgets_per_row: 3});
    tabs_widget.getTabContent("Attributes").appendChild(attrInsp.root);
    var aList = attrInsp.addList(null,[],{width: 200, height: 150, callback: attrClicked});
    var aInfo = attrInsp.addTextarea(null,"",{width: 300, height: 150, disabled:true});
    attrInsp.addSeparator();
    var aArgin = attrInsp.addString("Argin value","",{width: 400});
    var raButton = attrInsp.addButton(null,"Read", {width: 50, callback: readButtonClicked });
    var waButton = attrInsp.addButton(null,"Write", {width: 50, callback: writeButtonClicked });
    attrInsp.addSeparator();
    var aReply = attrInsp.addTextarea(null,"",{width: 500, height: 150, disabled:true});
    //
    var cmdInsp = new LiteGUI.Inspector({widgets_per_row: 3});
    tabs_widget.getTabContent("Commands").appendChild(cmdInsp.root);
    var cList = cmdInsp.addList(null,[],{width: 200, height: 150, callback: cmdClicked});
    var cInfo = cmdInsp.addTextarea(null,"",{width: 300, height: 150, disabled:true});
    cmdInsp.addSeparator();
    var cArgin = cmdInsp.addString("Argin value","",{width: 400});
    var cmButton = cmdInsp.addButton(null,"Execute", {width: 100, callback: execButtonClicked });
    cmdInsp.addSeparator();
    var cReply = cmdInsp.addTextarea(null,"",{width: 500, height: 150, disabled:true});
    //
    parent.add( tabs_widget );
    var selected_attr = null;
    var selected_cmd = null;
    //
    let sorted = Object.keys(dInfo.Attributes).sort();
    for (const key in sorted) {
        aList.addItem(sorted[key]);
    };
    //
    sorted = Object.keys(dInfo.Commands).sort();
    for (const key in sorted) {
        cList.addItem(sorted[key]);
    }
};


function donkiAddHostsList( tango_host, parentpanel, showpanel)
{
    var guiPanel = showpanel;
    var aInsp = donkiAddInspector(parentpanel, {widgets_per_row: 1});
    donkiAddSeparator(aInsp);
    donkiAddSection(aInsp,"Tango Hosts", {collapsed:false});
    //
    let req = new XMLHttpRequest();
    let web_url = "/tango-cs/CMD?td=" + tango_host + "/sys/database/2/DbGetServerList,Starter/*";
    req.open('GET', web_url, false);
    req.send(null);
    if(req.status != 200) {
        onWriteError(req.status +" "+req.statusText);
        return;
    };
    let dReply = JSON.parse(req.responseText);
    if (Array.isArray(dReply)) {
            hosts_result = dReply[0];
        } else  {
            hosts_result = dReply;
        };
    if (hosts_result.reply !== "***OK") return;
    //
    for (const key in hosts_result.value) {
        let hostname = hosts_result.value[key].split("/")[1];
        aInsp.addButton(null,hostname,{callback: function(name) { populateWithServers(guiPanel,hostname); } });
    };
    return;
};



function addDevServerItem(parent,srv_info,thost)
{
    let lcolors = {"ON":"lime","FAULT":"red","MOVING":"blue"};
    //
    lcolor = "orange";
    if (srv_info[1] in lcolors) {
        lcolor = lcolors[srv_info[1]];
    }
    let istate = srv_info[1];
    let iname = srv_info[0];
    let ititle = thost+"/"+iname;
    var element = document.createElement("span");
    element.innerHTML = '<b><font color='+lcolor+'></b>'+istate+'</font><big>  '+iname+'</big>';
    element.setAttribute("title", ititle);
    element.style.cursor = "pointer";
    element.addEventListener("click", onClick );
    element.style.display = "inline-block";
    element.style.width = "33%";
    //
    element.setValue = function(v) {
        if (this.getValue() == v) return;
        let txt_now = this.innerText.split(" ");
        lcolor = "orange";
        if (v in lcolors) {
            lcolor = lcolors[v];
        }
        this.innerHTML = '<b><font color='+lcolor+'></b>'+v+'</font><big>  '+txt_now[txt_now.length-1]+'</big>';
    }
    //
    element.getValue = function() {
        return this.innerText.split(" ")[0];
    }
    //
    function onClick(e) {
        let tginfo = this.title.split("/");
        // Create a new dialog
        var thost = tginfo[0];
        var dsname = tginfo[1]+"/"+tginfo[2];
        options = {};
        options.title = dsname;
        options.width = "auto";
        let choices = ["START","STOP","HARDKILL","Cancel"];
        if (this.getValue() == "ON") choices = ["STOP","HARDKILL","Cancel"];
        if (this.getValue() == "FAULT") choices = ["START","Cancel"];
        let dialog = LiteGUI.choice( dsname + "  [on " + thost +"]" , choices, inner, options);
        //
        function inner(v) {
            if (v == "Cancel") return;
                var tgcmd = TG_HOST + "/tango/admin/"+thost+"/";
                if (v == "STOP") tgcmd += "DevStop,"+dsname;
                if (v == "START") tgcmd += "DevStart,"+dsname;
                if (v == "HARDKILL") tgcmd += "HardKillServer,"+dsname;
                sendCommand(tgcmd, null, need_reply = false);
        };
        dialog.show('fade');
    }
    //
    parent.append(element,{});
    parent.processElement(element, {});
    // global var update
    starter_info["js_elements"][iname] = element;
    return element;
}        

function populateWithServers(guiPanel, thost) {
    //
    guiPanel.clear()
    guiPanel.root.querySelector(".panel-header").innerHTML = "Tango Servers Control";
    var aInsp = donkiAddInspector(guiPanel, {widgets_per_row: 3});
    // Title
    var aL = donkiAddLabel(aInsp,"Controlled servers on: "+thost,{style:"font-weight: bold;"});
    aL.style.fontWeight = "bold";
    aL.style.fontSize = "large";
    aL.style.color = "aqua";
    //
    // update global variable
    starter_info = {};
    starter_info["tangodev"] = starter_active = tango_host + "/tango/admin/"+thost+"/Servers";
    starter_info["js_elements"] = {};
    //
    let web_url = "/tango-cs/GETATTR?force=true&td=" + starter_active;
    let req = new XMLHttpRequest();
    req.open('GET', web_url, false);
    req.send(null);
    if(req.status != 200) {
        onWriteError(req.status +" "+req.statusText);
        return;
    };
    let dReply = JSON.parse(req.responseText);
    servers_result = dReply[0];
    let levels = {};
    for (const key in servers_result.value) {
        let srvinfo = servers_result.value[key].split("\t");
        let slevel = srvinfo[3];
        if (slevel in levels) {
            levels[slevel].push(srvinfo);
        } else {
            levels[slevel] = [srvinfo];
        }
    };
    for (const lvl in levels) {
        if (lvl < 1) continue;
        donkiAddSection(aInsp,"LEVEL " + lvl);
        for (const lk in levels[lvl]) {
            let aDSI = addDevServerItem(aInsp,levels[lvl][lk],thost);
            if ((lk % 2) == 1) donkiAddLineBreak(aInsp);
        }
    }
    if (0 in levels) {
        donkiAddSection(aInsp,"NOT CONTROLLED");
        for (const lk in levels[0]) {
            let aDSI = addDevServerItem(aInsp,levels[0][lk],thost);
            if ((lk % 2) == 1) donkiAddLineBreak(aInsp);
        }
    }
};

    
function populateMyArea( mainarea )
{
    //
    function switchTreeView(name_in) {
        donkiFillTangoTree(tango_host=TG_HOST, showpanel=rightPanel, litetree=tangoTree, view=name_in);
    };
    //
    if (typeof TG_HOST === "undefined") {
        TG_HOST="";
    };
    mainarea.split("horizontal",["300px", null],true);
    var rightPanel = new LiteGUI.Panel({ id: "right_panel", title:"Tango Device Control",close:true,scroll:true});
    //
    var tangoPanel = new LiteGUI.Panel({ id: "tango_panel", title:"TANGO Control System",close:true,scroll:true});
    
    var tangoTree = donkiCreateTangoTree(tango_host=TG_HOST, showpanel=rightPanel);
    donkiFillTangoTree(tango_host=TG_HOST, showpanel=rightPanel, litetree=tangoTree, view="Devices");
    var jInsp = donkiAddInspector(tangoPanel, {widgets_per_row: 1});
    donkiAddImage(jInsp,"/html/images/logo_tango.png", {height:60});
    donkiAddLineBreak(jInsp);
    jInsp.addComboButtons("View by","Devices",{values:["Devices","Servers"], callback: switchTreeView});
    donkiAddSeparator(jInsp);
    tangoPanel.add(tangoTree);
    donkiAddHostsList(tango_host=TG_HOST, parentpanel=tangoPanel, showpanel=rightPanel);
    //
    mainarea.getSection(0).add( tangoPanel )
    mainarea.getSection(1).add( rightPanel );
    //
    let intervalID = setInterval(periodicCallback, 2000);
}
